/*:
 *
 * @plugindesc 特定スイッチがONの場合、イベントが起動してもタッチ処理を継続します
 * @author liply
 *
 * @help
 * 特定スイッチがONの場合、イベントが起動してもタッチ処理を継続します
 * これにより、Event実行後足が止まるのを防ぎます。
 *
 * Target Switch
 * このスイッチがONの場合、タッチ処理を継続します。
 *
 * @param Target Switch
 * @default 10
 *
 */

(function(){
    'use strict';
    var parameters = PluginManager.parameters('liply_ContinueTouch');
    var targetSwitch = +parameters['Target Switch'];
    var fakeClear = false;

    var Game_Temp_clearDestination = Game_Temp.prototype.clearDestination;
    Game_Temp.prototype.clearDestination = function(){
        if($gameMap.isEventRunning() && targetSwitch && $gameSwitches.value(targetSwitch)){
            fakeClear = true;
        }else if(!fakeClear){
            Game_Temp_clearDestination.call(this);
        }
    };

    var Game_Temp_isDestinationValid = Game_Temp.prototype.isDestinationValid;
    Game_Temp.prototype.isDestinationValid = function(){
        if(fakeClear) return false;
        else return Game_Temp_isDestinationValid.call(this);
    };

    var Scene_Map_updateScene = Scene_Map.prototype.updateScene;
    Scene_Map.prototype.updateScene = function() {
        Scene_Map_updateScene.call(this);

        if(!$gameMap.isEventRunning()){
            fakeClear = false;
        }
    }

})();